<template>
  <div>
    <v-row justify="center">
      <v-dialog
        v-model="openDialog"
        persistent
        max-width="600px"
        @keydown.esc="openDialog = false"
        @keydown.enter="openPM()"
      >
        <v-card>
          <v-card-title>
            <span class="text-h5">{{ $ay.t("Open") }}</span>
          </v-card-title>
          <v-card-text>
            <v-text-field
              v-model="openPMNumber"
              :label="$ay.t('PM')"
              autofocus
              required
              type="number"
            ></v-text-field>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="blue darken-1" text @click="openDialog = false">{{
              $ay.t("Cancel")
            }}</v-btn>
            <v-btn
              color="blue darken-1"
              text
              :disabled="!openPMNumber"
              @click="openPM()"
              >{{ $ay.t("OK") }}</v-btn
            >
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-row>
    <gz-report-selector ref="reportSelector"></gz-report-selector>
    <gz-extensions
      ref="extensions"
      :aya-type="aType"
      :selected-items="selectedItems"
    >
    </gz-extensions>

    <gz-data-table
      ref="gzdatatable"
      form-key="pm-list"
      data-list-key="PMDataList"
      :show-select="rights.read"
      :reload="reload"
      data-cy="pmsTable"
      :client-criteria="clientCriteria"
      :pre-filter-mode="preFilterMode"
      @selection-change="handleSelected"
      @clear-pre-filter="clearPreFilter"
    >
    </gz-data-table>
  </div>
</template>
<script>
const FORM_KEY = "pm-list";
export default {
  data() {
    return {
      rights: window.$gz.role.defaultRightsObject(),
      aType: window.$gz.type.PM,
      selectedItems: [],
      reload: false,
      openDialog: false,
      openPMNumber: null,
      clientCriteria: undefined,
      preFilterMode: null,
      objectId: null,
      aForType: null,
      name: null
    };
  },
  async created() {
    this.rights = window.$gz.role.getRights(window.$gz.type.PM);
    window.$gz.eventBus.$on("menu-click", clickHandler);
    await fetchTranslatedText();
    //------ Show all ----
    //OPTIONAL "Show All" FILTER
    this.objectId = window.$gz.util.stringToIntOrNull(
      this.$route.params.objectId
    );
    this.aForType = window.$gz.util.stringToIntOrNull(this.$route.params.aType);

    if (this.objectId && this.objectId != 0 && this.aForType) {
      //OBJECTID,AYATYPE
      this.clientCriteria = `${this.objectId},${this.aForType}`;

      this.preFilterMode = {
        icon: window.$gz.util.iconForType(this.aForType),
        id: this.objectId,
        ayatype: this.aForType,
        viz: this.$route.params.name,
        clearable: true
      };
    }
    //------ /show all ----

    generateMenu(this);
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    handleSelected(selected) {
      this.selectedItems = selected;
    },
    clearPreFilter() {
      this.clientCriteria = null;
      this.preFilterMode = null;
      this.reload = !this.reload;
    },
    async openPM() {
      if (!this.openPMNumber) {
        return;
      }
      //get id from number then push open
      const res = await window.$gz.api.get(
        "pm/id-from-number/" + this.openPMNumber
      );
      if (res.error) {
        window.$gz.eventBus.$emit(
          "notify-warning",
          window.$gz.errorHandler.errorToString(res, this)
        );
        return;
      }

      this.$router.push({
        name: "pm-edit",
        params: { recordid: res.data }
      });
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "new":
        m.vm.$router.push({
          name: "pm-edit",
          params: { recordid: 0 }
        });
        break;
      case "extensions":
        {
          const res = await m.vm.$refs.extensions.open(
            m.vm.$refs.gzdatatable.getDataListSelection(window.$gz.type.PM)
          );
          if (res && res.refresh == true) {
            m.vm.reload = !m.vm.reload;
          }
        }
        break;
      case "report":
        {
          const res = await m.vm.$refs.reportSelector.open(
            m.vm.$refs.gzdatatable.getDataListSelection(window.$gz.type.PM),
            m.id
          );
          if (res == null) {
            return;
          }
          window.$gz.form.setLastReportMenuItem(FORM_KEY, res, m.vm);
        }
        break;
      case "WorkOrderItemList":
        m.vm.$router.push({
          name: "svc-pm-items"
        });
        break;
      case "open":
        m.vm.openDialog = true;
        break;
      case "newcustomer":
        m.vm.$router.push({
          name: "customer-edit",
          params: { recordid: 0 }
        });
        break;
      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: true,
    icon: "$ayiBusinessTime",
    title: "PMList",
    helpUrl: "svc-pms",
    menuItems: [],
    formData: {
      ayaType: window.$gz.type.PM
    }
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "New",
      icon: "$ayiPlus",
      surface: true,
      key: FORM_KEY + ":new",
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "Report",
    icon: "$ayiFileAlt",
    key: FORM_KEY + ":report",
    vm: vm
  });

  const lastReport = window.$gz.form.getLastReport(FORM_KEY);
  if (lastReport != null) {
    menuOptions.menuItems.push({
      title: lastReport.name,
      notrans: true,
      icon: "$ayiFileAlt",
      key: FORM_KEY + ":report:" + lastReport.id,
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "Extensions",
    icon: "$ayiPuzzlePiece",
    key: FORM_KEY + ":extensions",
    vm: vm
  });
  menuOptions.menuItems.push({
    title: "Open",
    icon: "$ayiTools",
    key: FORM_KEY + ":open",
    vm: vm
  });
  menuOptions.menuItems.push({ divider: true, inset: false });

  menuOptions.menuItems.push({
    title: "WorkOrderItemList",
    icon: "$ayiWrench",
    key: FORM_KEY + ":WorkOrderItemList",
    vm: vm
  });
  if (window.$gz.role.canChange(window.$gz.type.Customer)) {
    menuOptions.menuItems.push({
      title: "NewCustomer",
      icon: "$ayiAddressCard",
      key: FORM_KEY + ":newcustomer",
      vm: vm
    });
  }
  menuOptions.menuItems.push({ divider: true, inset: false });

  window.$gz.eventBus.$emit("menu-change", menuOptions);
}
//////////////////////////////////////////////////////////
//
// Ensures UI translated text is available
//
async function fetchTranslatedText() {
  await window.$gz.translation.cacheTranslations(["PM", "NewCustomer"]);
}
</script>
